package com.cool.hot100.heap;

import org.junit.Test;

import java.util.PriorityQueue;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/21/22:50
 * DayNumber 2
 * Hard 3
 * Level 6
 * @Description Num295
 */
public class MedianFinder {


    private PriorityQueue<Integer> minQueue;
    private PriorityQueue<Integer> maxQueue;

    public MedianFinder() {
        minQueue = new PriorityQueue<Integer>((a, b) -> (b - a));
        maxQueue = new PriorityQueue<Integer>((a, b) -> (a - b));
    }

    public void addNum(int num) {
        if (minQueue.isEmpty() || minQueue.peek() >= num) {
            minQueue.offer(num);
            if (minQueue.size() > maxQueue.size() + 1) {
                maxQueue.offer(minQueue.poll());
            }
        } else {
            maxQueue.offer(num);
            if (maxQueue.size() > minQueue.size()) {
                minQueue.offer(maxQueue.poll());
            }
        }
    }

    public double findMedian() {
        if (minQueue.size() > maxQueue.size()) {
            return minQueue.peek();
        }
        return (minQueue.peek() + maxQueue.peek()) / 2.0;
    }
    @Test
    public void test(){
        new MedianFinder().findMedian();
    }
}

